/******************************************************************************\
*                                                                              *
* 29/5/2009                                                                    *
* CameraTween - Source File                                                  *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/

//REQUIRED HEADERS 

#include <Animation/CameraTween.h>

//NAMESPACE

using namespace std;

//PRIVATE DEFINITIONS TYPEDEFS

//

/****************************************************************************\
* STATIC                                                                     *
\****************************************************************************/

//MEMBER

//METHODS

/****************************************************************************\
* CD                                                                         *
\****************************************************************************/

CameraTween::CameraTween(View *pView, QRectF &frameRect,QPointF nodePos)
{
	m_pView = pView;
	m_fromRect = m_pView->GetViewRect();
	m_toRect = m_pView->ComputeToRect(frameRect,nodePos);
	m_started = false;
}

CameraTween::~CameraTween()
{

}

/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/
void CameraTween::Tween( float dVal )
{
	if(!m_started)
	{
		m_pView->setDragMode(QGraphicsView::NoDrag);
		m_started = true;
	}

	QRectF resultR;
	resultR.setLeft((dVal*m_toRect.left())+((1.0f-dVal)*m_fromRect.left()));
	resultR.setRight((dVal*m_toRect.right())+((1.0f-dVal)*m_fromRect.right()));
	resultR.setTop((dVal*m_toRect.top())+((1.0f-dVal)*m_fromRect.top()));
	resultR.setBottom((dVal*m_toRect.bottom())+((1.0f-dVal)*m_fromRect.bottom()));
	m_pView->LookAt(resultR);
}

void CameraTween::Destroy()
{
	m_pView->setDragMode(QGraphicsView::ScrollHandDrag);
	delete this;
}

/****************************************************************************\
* PROTECTED CLASS FUNCTIONS                                                  *
\****************************************************************************/

/****************************************************************************\
* PRIVATE CLASS FUNCTIONS                                                    *
\****************************************************************************/