/******************************************************************************\
*                                                                              *
* 24/4/2009                                                                    *
* NodeTween - Source File                                                      *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/

//REQUIRED HEADERS 

#include <Animation/NodeTween.h>
#include <Graph/TreeNode.h>
#include <Memory/mmgr.h>

//NAMESPACE

using namespace std;

//PRIVATE DEFINITIONS TYPEDEFS

//

/****************************************************************************\
* STATIC                                                                     *
\****************************************************************************/

//MEMBER

//METHODS

/****************************************************************************\
* CD                                                                         *
\****************************************************************************/

NodeTween::NodeTween(TreeNode *tNode, Vector2f &fromPos, Vector2f &toPos)
{
	m_pNode = tNode;
	m_fromPos = fromPos;
	m_toPos = toPos;
}

NodeTween::~NodeTween()
{
	
}

/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/

void NodeTween::Tween( float dVal )
{
	Vector2f nodePos  = Vector2f::Interpolate(m_fromPos,m_toPos,dVal);
	m_pNode->SetPosition(nodePos.m_X,nodePos.m_Y);
}

void NodeTween::Destroy()
{
	delete this;
}

/****************************************************************************\
* PROTECTED CLASS FUNCTIONS                                                  *
\****************************************************************************/

/****************************************************************************\
* PRIVATE CLASS FUNCTIONS                                                    *
\****************************************************************************/