/******************************************************************************\
*                                                                              *
* 24/5/2009                                                                    *
* NodeTweenNew - Source File                                                   *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/

//REQUIRED HEADERS 

#include <Animation//NodeTweenNew.h>
#include <Memory/mmgr.h>

//NAMESPACE

using namespace std;

//PRIVATE DEFINITIONS TYPEDEFS

//

/****************************************************************************\
* STATIC                                                                     *
\****************************************************************************/

//MEMBER

//METHODS

/****************************************************************************\
* CD                                                                         *
\****************************************************************************/

NodeTweenNew::NodeTweenNew(TreeNode *tNode, PreviewNodeRep *pNodeRep, Vector2f toPos) :
	NodeTween(tNode,Vector2f(pNodeRep->GetScenePos().x(),pNodeRep->GetScenePos().y()),toPos)
{
	m_pPreviewNodeRep = pNodeRep;
	m_pTreeNodeRep = static_cast<TreeNodeRep *>(&tNode->GetNodeRep());
	m_pTreeNodeRep->SetState(pNodeRep->GetState());
	Tween(0.0f);
}

NodeTweenNew::~NodeTweenNew()
{

}

/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/

//TWEEN
void NodeTweenNew::Tween( float dVal )
{	
	if(dVal == 0.0f)
	{
		//above preview window
		m_pTreeNodeRep->setZValue(600000);
		//set invisible
		m_pTreeNodeRep->setVisible(false);
		//set heightscale
		m_pTreeNodeRep->SetHeightScale(m_pPreviewNodeRep->GetNodeHeightScale());
	}
	else
	{
		//set Visible
		m_pTreeNodeRep->setVisible(true);
	}

	if(dVal >0.9999f)
	{
		//below preview window
		m_pTreeNodeRep->setZValue(0);
	}

	//update and tween node scale
	float scale = dVal * (1.0f) + (1.0f - dVal) * PreviewNodeRep::GetGlobalScale();
	m_pTreeNodeRep->setTransform(QTransform(QMatrix().scale(scale,scale)));
	
	//tween the look
	static float dPi = (3.0f * MY_PI / 2.0f) - MY_PI;
	float val = 1 + cosf(MY_PI + dPi*dVal);
	m_pTreeNodeRep->Mutate(val);
	
	//update fromPos
	m_fromPos = Vector2f(m_pPreviewNodeRep->GetScenePos().x(),m_pPreviewNodeRep->GetScenePos().y());

	//tween pos
	NodeTween::Tween(dVal);
}

/****************************************************************************\
* PROTECTED CLASS FUNCTIONS                                                  *
\****************************************************************************/

/****************************************************************************\
* PRIVATE CLASS FUNCTIONS                                                    *
\****************************************************************************/