#ifndef TWEENER_H
#define TWEENER_H

/******************************************************************************\
*                                                                              *
* 15/4/2009                                                                    *
* Tweener - Header File                                                        *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/
/******************************************************************************\
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX DESCRIPTION XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
\******************************************************************************/

//REQUIRED HEADERS 

#include <Definitions.h>
#include <QObject>

//DECLARATIONS

class Tweenable;

/******************************************************************************\
* CLASS                                                                        *
\******************************************************************************/
class Tweener : public QObject
{
	Q_OBJECT;

	public:

		//CLASS STATIC DEFINITIONS

		//METHODS

		Tweener();
		~Tweener();

		void StartTween();
		void AddTweenable(Tweenable *pTweenable);
		inline int GetNmbTweenable(){return m_nmbTweenable;}
		inline void SetNext(Tweener *pNext){m_pNext = pNext;}
		inline Tweener * GetNext(){return m_pNext;}
		inline void SetDuration(int duration,bool singleShot = false){m_duration = duration;m_singleShot = singleShot;}


		virtual void OnStart() { }
		virtual void OnEnd() { }
	
	protected:

		//METHODS

		virtual void timerEvent(QTimerEvent *event);
		Tweener *m_pNext;
	private:

		//MEMBER

		int m_timerID;
		int m_interval;
		float m_elapsed;
		float m_duration;
		int m_nmbTweenable;
		bool m_singleShot;
		
	
	signals:

		void UpdateTweenable(float dVal);
		void KillTweenable();
}; 

#endif //TWEENER_H