/******************************************************************************\
*                                                                              *
* 24/5/2009                                                                    *
* TweenerNew - Source File                                                     *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/

//REQUIRED HEADERS 

#include <Animation/TweenerFinish.h>
#include <TreePlusSettings.h>
#include <Graph/TreeNode.h>
#include <Graph/TreeLink.h>
#include <Graph/Tree.h>
#include <TreeLinkRep.h>
#include <Memory/mmgr.h>

//NAMESPACE

using namespace std;

//PRIVATE DEFINITIONS TYPEDEFS

//

/****************************************************************************\
* STATIC                                                                     *
\****************************************************************************/

//MEMBER

//METHODS

/****************************************************************************\
* CD                                                                         *
\****************************************************************************/
TweenerFinish::TweenerFinish(View *pView,TreePlusSettings *pSettings,Tree *pTree)
{
	SetDuration(0,true);
	m_pView = pView;
	m_pTree = pTree;
	m_pSettings = pSettings;
}

/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/

void TweenerFinish::SetExpandedNode(TreeNode *pExpandedNode)
{
	m_pExpandedNode = pExpandedNode;
}

void TweenerFinish::OnStart()
{

}

void TweenerFinish::OnEnd()
{
	list<TreeNode *> children;
	m_pExpandedNode->GetChildren(children);
	for(list<TreeNode *>::iterator it = children.begin(); it != children.end(); it++)
	{
		(*it)->GetLinkToParent()->GetTreeLinkRep().show();
	}

	m_pView->LockInput(false);
	m_pSettings->setEnabled(true);
	m_pTree->ExploreNode(m_pTree->GetActualNode());
}