/******************************************************************************\
*                                                                              *
* 20/4/2009                                                                    *
* TweenerSetRootStep1 - Source File                                            *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/

//REQUIRED HEADERS 

#include <Animation/TweenerSetRootStep1.h>
#include <Animation/NodeTween.h>
#include <Graph/Tree.h>
#include <Graph/TreeNodeImpl.h>
#include <Graph/TreeLink.h>
#include <TreeLinkrep.h>
#include <Memory/mmgr.h>

//NAMESPACE

using namespace std;

//PRIVATE DEFINITIONS TYPEDEFS

//

/****************************************************************************\
* STATIC                                                                     *
\****************************************************************************/

//MEMBER

//METHODS

/****************************************************************************\
* CD                                                                         *
\****************************************************************************/
TweenerSetRootStep1::TweenerSetRootStep1()
{

}

void TweenerSetRootStep1::SetTree(Tree *tree)
{
	m_tree = tree;
}
	
/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/
void TweenerSetRootStep1::OnStart()
{

}

void TweenerSetRootStep1::OnEnd()
{
	TreeNodeImpl *root = static_cast<TreeNodeImpl *>(m_tree->GetRoot());
	m_tree->RemoveChildren(root);
	
	map<int, TreeNode*> catalog = m_tree->GetTreeNodeCatalog().GetAll();
	for(map<int, TreeNode*>::iterator it = catalog.begin(); it != catalog.end(); it++)
	{
		if(it->first != root->GetId())
		{
			m_tree->RemoveNode(it->second);
		}
	}
	//store old position
	Vector2f oldPos(root->GetPosition());
	
	//calculate new position
	m_tree->ExpandNode(root, false);
	catalog = m_tree->GetTreeNodeCatalog().GetAll();
	for(map<int, TreeNode*>::iterator it = catalog.begin(); it != catalog.end(); it++) 
	{
		it->second->SetAnimationGroup(ANIMATE_TREE_POSITION_FIX);
	}
	m_tree->SetLayout();

	Vector2f newPos(root->GetPosition());

	//reset to old position
	root->SetPosition(oldPos[0], oldPos[1]);

	list<TreeNode *> children;
	root->GetChildren(children);
	for(list<TreeNode *>::iterator it = children.begin(); it != children.end(); it++)
	{
		(*it)->GetNodeRep().hide();
		(*it)->GetLinkToParent()->GetTreeLinkRep().hide();
	}
	m_pNext->AddTweenable(new NodeTween(root, oldPos, newPos));

	m_tree->ExploreNode(root);
}