/******************************************************************************\
*                                                                              *
* 20/4/2009                                                                    *
* TweenerSetRootStep2 - Source File                                            *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/

//REQUIRED HEADERS 

#include <Animation/TweenerSetRootStep2.h>
#include <Animation/NodeTween.h>
#include <Graph/Tree.h>
#include <Graph/TreeNode.h>
#include <Graph/TreeLink.h>
#include <TreeLinkrep.h>
#include <Memory/mmgr.h>

//NAMESPACE

using namespace std;

//PRIVATE DEFINITIONS TYPEDEFS

//

/****************************************************************************\
* STATIC                                                                     *
\****************************************************************************/

//MEMBER

//METHODS

/****************************************************************************\
* CD                                                                         *
\****************************************************************************/
TweenerSetRootStep2::TweenerSetRootStep2()
{

}

void TweenerSetRootStep2::SetTree(Tree *tree)
{
	m_tree = tree;
}
	
/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/
void TweenerSetRootStep2::OnStart()
{

}

void TweenerSetRootStep2::OnEnd()
{
	TreeNode *root = m_tree->GetRoot();
	list<TreeNode *> children;
	root->GetChildren(children);
	for(list<TreeNode *>::iterator it = children.begin(); it != children.end(); it++)
	{
		(*it)->GetNodeRep().show();
		//(*it)->GetLinkToParent()->GetTreeLinkRep().show();
		Vector2f newPos((*it)->GetPosition());
		(*it)->SetPosition(root->GetPosition()[0], root->GetPosition()[1]);
		m_pNext->AddTweenable(new NodeTween(*it, root->GetPosition(), newPos));
	}
}