/****************************************************************************\
*                                                                            *
* 05.10.2008                                                                 *
* Definitions - Header File                                                  *
*                                                                            *
* (c) Robert Hausmair                                                        *
*                                                                            *
\****************************************************************************/

#ifndef __DEFINITIONS_H__
#define __DEFINITIONS_H__

//Switch off warnings
#pragma warning(disable: 4786)  //Switch off debug length warning (in vector)
#pragma warning(disable :4996)  //Depreciated functions
#pragma warning(disable :4800)  //Forcing value to bool
#pragma warning(disable :4018)  //signed unsigned mismatch
#pragma warning(disable :4244)  //conversion from int to float
#pragma warning(disable :4100)  //unreferenced formal parameter

/********************************\
* REQUIRED HEADERS               *
\********************************/

#include <assert.h>
#include <string>
#include <vector>
#include <iostream>

/********************************\
* DEFINITIONS                    *
\********************************/

//type redefinitions
typedef unsigned    char uchar;
typedef unsigned   short ushort;
typedef unsigned     int uint;
typedef unsigned    long ulong;
typedef unsigned __int64 uqword;
typedef signed   __int64 qword;

//constants
const float MY_PI = 3.141592654f;

//delete makros
#define SAFE_DELETE(p)       {  if(p) {delete    (p);   (p) = NULL;}  }
#define SAFE_DELETE_ARRAY(p) {  if(p) {delete [] (p);   (p) = NULL;}  }

#endif