#ifndef TREENODE_H
#define TREENODE_H

/******************************************************************************\
*                                                                              *
* 1/4/2009                                                                     *
* TreeNode - Header File                                                       *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/
/******************************************************************************\
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX DESCRIPTION XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
\******************************************************************************/

//REQUIRED HEADERS 

#include <Definitions.h>
#include <Math/Vector2.h>
#include <list>
//DECLARATIONS

class Tree;
class TreeLink;
class NodeRep;

//PUBLIC DEFINITIONS TYPEDEFS

#define ANIMATE_TREE_MOVE 0
#define ANIMATE_TREE_FIXED 1
#define ANIMATE_TREE_NEW 2
#define ANIMATE_TREE_POSITION_FIX 3

#define TYPE_NODE 0
#define TYPE_NODE_MOVEDTO 1

/******************************************************************************\
* CLASS                                                                        *
\******************************************************************************/
class TreeNode
{
	public:

		//CLASS STATIC DEFINITIONS

		//ENUM //VAR //METHODS 

		//METHODS
		virtual ~TreeNode() {}

		virtual int GetId() = 0;
		//virtual const DataNode& GetDataNode() = 0;
		virtual NodeRep & GetNodeRep() = 0;
		virtual TreeNode * GetParentNode() = 0;
		virtual TreeLink * GetLinkToParent() = 0;
		virtual Tree & GetTree() = 0;
		
		virtual void SetParentNode(TreeNode *parent) = 0;
		virtual void AddChild(TreeNode *node) = 0;
		virtual void RemoveChild(TreeNode *node) = 0;
		virtual void GetChildren(std::list<TreeNode *>& children) = 0;

		virtual void OnNodeClick(NodeRep *previous) = 0;
		virtual void OnNodeDoubleClick() = 0;
		virtual void OnNodeShapeChange() = 0;
		virtual void OnNodeRightClick() = 0;
		virtual void OnNodeHoverEnter() = 0;
		virtual void OnNodeHoverLeave() = 0;

		virtual void SetAnimationGroup(int group) = 0;
		virtual int GetAnimationGroup() = 0;

		virtual Vector2f GetPosition() = 0;
		virtual void SetPosition(float x,float y) = 0;
		virtual void SortChildren() = 0;

		virtual int GetType() = 0;
		
		//MEMBER

		//

	protected:

		//CLASS STATIC DEFINITIONS

		//ENUM //VAR //METHODS

		//METHODS

		//

		//MEMBER

		//

	private:

		//CLASS STATIC DEFINITIONS

		//METHODS

		//MEMBER
}; 

#endif //TREENODE_H