/******************************************************************************\
*                                                                              *
* 4/4/2009                                                                     *
* TreeNodeCatalog - Source File                                                *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/

//REQUIRED HEADERS 

#include <Graph/TreeNodeCatalog.h>
#include <Graph/TreeNode.h>
#include <algorithm>
#include <Memory/mmgr.h>

//NAMESPACE

using namespace std;

//PRIVATE DEFINITIONS TYPEDEFS

//

/****************************************************************************\
* STATIC                                                                     *
\****************************************************************************/

//MEMBER

//METHODS

/****************************************************************************\
* CD                                                                         *
\****************************************************************************/

TreeNodeCatalog::TreeNodeCatalog()
{

}

TreeNodeCatalog::~TreeNodeCatalog()
{
	
}

/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/

//ON NODE DOUBLE CLICK
bool TreeNodeCatalog::Insert(int id, TreeNode * elem)
{
	std::map<int, TreeNode *>::iterator result = m_content.find(id);
	if(result == m_content.end())
	{
		m_content.insert(make_pair(id, elem));
		return true;
	}
	else
	{
		return false;
	}
}

bool TreeNodeCatalog::Remove(int id)
{
	std::map<int, TreeNode *>::iterator result = m_content.find(id);
	if(result != m_content.end())
	{
		m_content.erase(result);
		return true;
	}
	else
	{
		return false;
	}
}

TreeNode * TreeNodeCatalog::Find(int id)
{
	std::map<int, TreeNode *>::iterator result = m_content.find(id);
	if(result != m_content.end())
	{
		return result->second;
	}
	else
	{
		return NULL;
	}
}

void TreeNodeCatalog::ForEach( TreeNodeTransform *transform )
{
	map<int,TreeNode*>::iterator it = m_content.begin();

	while(it != m_content.end())
	{
		(*transform)(*it);
		++it;
	}
}

map<int, TreeNode *> & TreeNodeCatalog::GetAll()
{
	return m_content;
}

/****************************************************************************\
* PROTECTED CLASS FUNCTIONS                                                  *
\****************************************************************************/

/****************************************************************************\
* PRIVATE CLASS FUNCTIONS                                                    *
\****************************************************************************/