#ifndef TREENODEIMPL_H
#define TREENODEIMPL_H

/******************************************************************************\
*                                                                              *
* 1/4/2009                                                                     *
* TreeNode - Header File                                                       *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/
/******************************************************************************\
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX DESCRIPTION XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
\******************************************************************************/

//REQUIRED HEADERS 

#include <Definitions.h>
#include <Graph/TreeNode.h>
#include <Graph/DataNode.h>
#include <TreeNodeRep.h>
#include <Math/Vector2.h>

//DECLARATIONS

class Tree;
class TreeLink;
class TreeNodeMovedTo;

//PUBLIC DEFINITIONS TYPEDEFS

/******************************************************************************\
* CLASS                                                                        *
\******************************************************************************/
class TreeNodeImpl : public TreeNode
{
	public:

		//CLASS STATIC DEFINITIONS

		//ENUM //VAR //METHODS 

		//METHODS

		TreeNodeImpl(DataNode &data, Tree &tree, TreeNode *parent);
		~TreeNodeImpl();

		inline int GetId(){return m_DataNode.GetId();}
		inline DataNode& GetDataNode() { return m_DataNode;}
		inline NodeRep & GetNodeRep() { return *m_pNodeRep;}
		inline TreeNode * GetParentNode() { return m_parentNode;}
		inline TreeLink * GetLinkToParent() { return m_linkToParent;}
		inline Tree & GetTree() {return m_tree;}
		
		void SetParentNode(TreeNode *parent);
		void AddChild(TreeNode *node);
		void RemoveChild(TreeNode *node);
		void GetChildren(std::list<TreeNode *>& children);
		TreeNodeMovedTo *GetNodeMovedTo();

		void OnNodeClick(NodeRep *previous);
		void OnNodeDoubleClick();
		void OnNodeShapeChange();
		void OnNodeRightClick();
		void OnNodeHoverEnter();
		void OnNodeHoverLeave();

		inline void SetAnimationGroup(int group){m_animationGroup = group;}
		inline int GetAnimationGroup(){return m_animationGroup;}

		Vector2f GetPosition();
		void SetPosition(float x,float y);
		int GetType() {return TYPE_NODE;}
		void SortChildren();

		//MEMBER

		//

	protected:

		//CLASS STATIC DEFINITIONS

		//ENUM //VAR //METHODS

		//METHODS

		//

		//MEMBER

		//

	private:

		//CLASS STATIC DEFINITIONS

		//METHODS

		//MEMBER

		Tree &m_tree;
		DataNode &m_DataNode;
		TreeNodeRep *m_pNodeRep;
				
		TreeNode *m_parentNode;
		TreeLink *m_linkToParent;
		std::list<TreeNode *> m_children;

		int m_animationGroup;
}; 

#endif //TREENODE_H