#ifndef TREENODEMOVEDTO_H
#define TREENODEMOVEDTO_H

/******************************************************************************\
*                                                                              *
* 26/5/2009                                                                    *
* TreeNodeMovedTo - Header File                                                *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/
/******************************************************************************\
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX DESCRIPTION XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
\******************************************************************************/

//REQUIRED HEADERS 

#include <Definitions.h>
#include <Graph/TreeNode.h>
#include <Graph/DataNode.h>
#include <TreeNodeRep.h>
#include <Math/Vector2.h>

//DECLARATIONS

class Tree;
class TreeLink;
class TreeNodeImpl;

//PUBLIC DEFINITIONS TYPEDEFS

/******************************************************************************\
* CLASS                                                                        *
\******************************************************************************/
class TreeNodeMovedTo : public TreeNode
{
	public:

		//CLASS STATIC DEFINITIONS

		//ENUM //VAR //METHODS 

		//METHODS

		TreeNodeMovedTo(Tree &tree, TreeNode *parent, int id);
		~TreeNodeMovedTo();

		inline int GetId(){return m_id;}
		inline NodeRep & GetNodeRep() { return *m_pNodeRep;}
		inline TreeNode * GetParentNode() { return m_parentNode;}
		inline TreeLink * GetLinkToParent() { return m_linkToParent;}
		inline Tree & GetTree() {return m_tree;}
		
		void SetParentNode(TreeNode *parent) {}
		void AddChild(TreeNode *node) {}
		void RemoveChild(TreeNode *node) {}
		void GetChildren(std::list<TreeNode *>& children) {}

		void OnNodeClick(NodeRep *previous) {}
		void OnNodeDoubleClick() {}
		void OnNodeShapeChange() {}
		void OnNodeRightClick() {}
		void OnNodeHoverEnter();
		void OnNodeHoverLeave();

		inline void SetAnimationGroup(int group){m_animationGroup = group;}
		inline int GetAnimationGroup(){return m_animationGroup;}

		Vector2f GetPosition();
		void SetPosition(float x,float y);
		int GetType() {return TYPE_NODE_MOVEDTO;}
		void AddMovedToNodes(TreeNodeImpl *node);
		void RemoveFromMovedToNodes(TreeNodeImpl *node);
		int GetSizeMovedToNodes() {return m_movedTo.size();}
		void SortChildren() { }

		//MEMBER

		//

	protected:

		//CLASS STATIC DEFINITIONS

		//ENUM //VAR //METHODS

		//METHODS

		//

		//MEMBER

		//

	private:

		//CLASS STATIC DEFINITIONS

		//METHODS

		//MEMBER

		Tree &m_tree;
		int m_id;
		TreeNodeRep *m_pNodeRep;
				
		TreeNode *m_parentNode;
		TreeLink *m_linkToParent;
		std::list<TreeNodeImpl *> m_movedTo;

		int m_animationGroup;
}; 

#endif //TREENODEMOVEDTO_H