#ifndef TREELAYOUT_H
#define TREELAYOUT_H

/******************************************************************************\
*                                                                              *
* 15/4/2009                                                                    *
* TreeLayout - Header File                                                     *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/
/******************************************************************************\
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX DESCRIPTION XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
\******************************************************************************/

//REQUIRED HEADERS 

#include <Definitions.h>

#include <map>

//DECLARATIONS

class Tree;
class TreeNode;

//PUBLIC DEFINITIONS TYPEDEFS

//

/******************************************************************************\
* CLASS                                                                        *
\******************************************************************************/
class TreeLayout 
{
	public:

		//CLASS STATIC DEFINITIONS

		static float m_siblingSeparation;
		static float m_levelSeparation;
		static float m_subtreeSeparation;

		static void SetSiblingSeparation(float value);
		static void SetLevelSeparation(float value);
		static void SetSubtreeSeparation(float value);

		//ENUM //VAR //METHODS 

		//METHODS

		TreeLayout();
		~TreeLayout();

		bool Position(Tree &tree);
		

		//MEMBER

		//

	protected:

		//CLASS STATIC DEFINITIONS

		//ENUM //VAR //METHODS

		//METHODS

		//

		//MEMBER

		//

	private:

		//CLASS STATIC DEFINITIONS

		//ENUM //VAR //METHODS

		//METHODS

		void Firstwalk(TreeNode *node, int level);
		bool Secondwalk(TreeNode *node, int level, int modsum);
		void Apportion(TreeNode *node, int level);

		float GetMeanNodeSize(TreeNode *nodeOne, TreeNode *nodeTwo);
		bool IsCheckExtentsRange(float x, float y);
		
		//MEMBER
		
		Tree *m_tree;
		std::map<TreeNode*, float> m_modifier;
		std::map<TreeNode*, float> m_prelim;
		//map <TreeNode*, TreeNode *> leftNeighbor;
		float m_xTopAdjustment;
		float m_yTopAdjustment;
	
}; 

#endif //TREELAYOUT_H