/******************************************************************************\
*                                                                              *
* 4/4/2009                                                                     *
* GraphMlHandler - Source File                                                     *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/

//REQUIRED HEADERS 

#include <Xml/GraphMlHandler.h>
#include <Graph/Graph.h>
#include <Memory/mmgr.h>

//NAMESPACE

using namespace std;

//PRIVATE DEFINITIONS TYPEDEFS

//

/****************************************************************************\
* STATIC                                                                     *
\****************************************************************************/

//MEMBER

//METHODS

/****************************************************************************\
* CD                                                                         *
\****************************************************************************/

GraphMlHandler::GraphMlHandler()
{
	
}

GraphMlHandler::~GraphMlHandler()
{

}

/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/

bool GraphMlHandler::startElement(const QString &namespaceURI, const QString &localName,
						const QString &qName, const QXmlAttributes &attributes)
{
	if(qName == "node")
	{
		int id = attributes.value("id").toInt();
		m_mapIds[id] = m_nodes.size();
		m_nodes.push_back(DataNode());
		m_nodes.back().SetId(m_nodes.size() - 1);
	}
	else if(qName == "edge")
	{
		if(m_relations.size() == 0) {
			m_relations.resize(m_nodes.size());
			for(int i=0; i<m_nodes.size(); i++)
			{
				m_relations[i].resize(m_nodes.size(), false);
			}
		}
		int from = m_mapIds[attributes.value("source").toInt()];
		int to = m_mapIds[attributes.value("target").toInt()];
		m_relations[from][to] = true;
	}

	m_currentText.clear();
	return true;
}

bool GraphMlHandler::endElement(const QString &namespaceURI, const QString &localName,
						const QString &qName)
{
	if(qName == "data")
	{
		m_nodes.back().SetName(m_currentText);
	}
	return true;
}

bool GraphMlHandler::characters(const QString &str)
{
	m_currentText += str;
    return true;
}

bool GraphMlHandler::fatalError(const QXmlParseException &exception)
{
	return true;
}

QString GraphMlHandler::errorString() const
{
	return "";
}

vector<DataNode> GraphMlHandler::GetNodes() const
{
	return m_nodes;
}

std::vector<std::vector<bool> > GraphMlHandler::GetRelations() const
{
	return m_relations;
}

/****************************************************************************\
* PROTECTED CLASS FUNCTIONS                                                  *
\****************************************************************************/

/****************************************************************************\
* PRIVATE CLASS FUNCTIONS                                                    *
\****************************************************************************/