/******************************************************************************\
*                                                                              *
* 4/4/2009                                                                     *
* ParseGraph - Source File                                                     *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/

//REQUIRED HEADERS 

#include <Xml/ParseGraph.h>
#include <Xml/XmlHandler.h>
#include <Xml/GraphMlHandler.h>
#include <Graph/Graph.h>
#include <Memory/mmgr.h>

//NAMESPACE

using namespace std;

//PRIVATE DEFINITIONS TYPEDEFS

//

/****************************************************************************\
* STATIC                                                                     *
\****************************************************************************/

//MEMBER

//METHODS

/****************************************************************************\
* CD                                                                         *
\****************************************************************************/

ParseGraph::ParseGraph(const QString &filename) :
	m_filename(filename)
{
	
}

ParseGraph::~ParseGraph()
{

}

/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/

//Create the graph
Graph * ParseGraph::CreateGraph()
{
	//XmlHandler handler;
	GraphMlHandler handler;
	QXmlSimpleReader reader;
	reader.setContentHandler(&handler);
    reader.setErrorHandler(&handler);

	QFile file(m_filename);
	if (!file.open(QFile::ReadOnly | QFile::Text))
	{
		return NULL;
	}

	QXmlInputSource xmlInputSource(&file);
	if(reader.parse(xmlInputSource))
	{
		return new Graph(handler.GetNodes(), handler.GetRelations());
	}
	else 
	{
		return NULL;
	}
}

/****************************************************************************\
* PROTECTED CLASS FUNCTIONS                                                  *
\****************************************************************************/

/****************************************************************************\
* PRIVATE CLASS FUNCTIONS                                                    *
\****************************************************************************/