/******************************************************************************\
*                                                                              *
* 4/4/2009                                                                     *
* XmlHandler - Source File                                                     *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/

//REQUIRED HEADERS 

#include <Xml/XmlHandler.h>
#include <Graph/Graph.h>
#include <Memory/mmgr.h>

//NAMESPACE

using namespace std;

//PRIVATE DEFINITIONS TYPEDEFS

//

/****************************************************************************\
* STATIC                                                                     *
\****************************************************************************/

//MEMBER

//METHODS

/****************************************************************************\
* CD                                                                         *
\****************************************************************************/

XmlHandler::XmlHandler()
{
	
}

XmlHandler::~XmlHandler()
{

}

/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/

bool XmlHandler::startElement(const QString &namespaceURI, const QString &localName,
						const QString &qName, const QXmlAttributes &attributes)
{
	if(qName == "node")
	{
		m_nodes.push_back(DataNode());
	}
	else if(qName == "relations")
	{
		m_relations.resize(m_nodes.size());
		for(int i=0; i<m_nodes.size(); i++)
		{
			m_relations[i].resize(m_nodes.size(), false);
		}
	}


	m_currentText.clear();
	return true;
}

bool XmlHandler::endElement(const QString &namespaceURI, const QString &localName,
						const QString &qName)
{
	if(qName == "node")
	{
		
	}
	else if(qName == "id")
	{
		m_nodes.back().SetId(m_currentText.toInt());
	}
	else if(qName == "url")
	{
		m_nodes.back().SetUrl(m_currentText);
	}
	else if(qName == "name")
	{
		m_nodes.back().SetName(m_currentText);
	}
	else if(qName == "author")
	{
		m_nodes.back().SetAuthor(m_currentText);
	}
	else if(qName == "keyword")
	{
		m_nodes.back().AddKeyword(m_currentText);
	}
	else if(qName == "from")
	{
		m_currentFrom = m_currentText.toInt();
	}
	else if(qName == "to")
	{
		int colInd = m_currentText.toInt();
		m_relations[m_currentFrom][colInd] = true;
	}
	return true;
}

bool XmlHandler::characters(const QString &str)
{
	m_currentText += str;
    return true;
}

bool XmlHandler::fatalError(const QXmlParseException &exception)
{
	return true;
}

QString XmlHandler::errorString() const
{
	return "";
}

vector<DataNode> XmlHandler::GetNodes() const
{
	return m_nodes;
}

std::vector<std::vector<bool> > XmlHandler::GetRelations() const
{
	return m_relations;
}

/****************************************************************************\
* PROTECTED CLASS FUNCTIONS                                                  *
\****************************************************************************/

/****************************************************************************\
* PRIVATE CLASS FUNCTIONS                                                    *
\****************************************************************************/