#ifndef XMLHANDLER_H
#define XMLHANDLER_H

/******************************************************************************\
*                                                                              *
* 4/4/2009                                                                     *
* XmlHandler - Header File                                                     *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/
/******************************************************************************\
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX DESCRIPTION XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
\******************************************************************************/

//REQUIRED HEADERS 

#include <Definitions.h>
#include <Graph/DataNode.h>
#include <QXmlDefaultHandler>

//DECLARATIONS

//

//PUBLIC DEFINITIONS TYPEDEFS

//

/******************************************************************************\
* CLASS                                                                        *
\******************************************************************************/
class XmlHandler : public QXmlDefaultHandler
{
	public:

		//CLASS STATIC DEFINITIONS

		//ENUM //VAR //METHODS 

		//METHODS

		XmlHandler();
		~XmlHandler();

		bool startElement(const QString &namespaceURI, const QString &localName,
						const QString &qName, const QXmlAttributes &attributes);
		bool endElement(const QString &namespaceURI, const QString &localName,
						const QString &qName);
		bool characters(const QString &str);
		bool fatalError(const QXmlParseException &exception);
		QString errorString() const;

		std::vector<DataNode> GetNodes() const;
		std::vector<std::vector<bool> > GetRelations() const;

		//MEMBER


		//

	protected:

		//CLASS STATIC DEFINITIONS

		//ENUM //VAR //METHODS

		//METHODS

		//

		//MEMBER

		//

	private:

		//CLASS STATIC DEFINITIONS

		//ENUM //VAR //METHODS

		//METHODS

		//

		//MEMBER
		QString m_currentText;
		uint m_currentFrom;
		std::vector<DataNode> m_nodes;
		std::vector<std::vector<bool> > m_relations;
}; 

#endif //XMLHANDLER_H