#ifndef PREVIEWNODE_H
#define PREVIEWNODE_H

/******************************************************************************\
*                                                                              *
* 19/4/2009                                                                    *
* PreviewNodeRep - Header File                                                 *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/
/******************************************************************************\
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX DESCRIPTION XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
\******************************************************************************/

//REQUIRED HEADERS 

#include <Definitions.h>
#include <NodeRep.h>

//DECLARATIONS

//PUBLIC DEFINITIONS TYPEDEFS

/******************************************************************************\
* CLASS                                                                        *
\******************************************************************************/
class PreviewNodeRep : public NodeRep
{
	public:

		//CLASS STATIC DEFINITIONS

		static void Init();
		static float GetGlobalScale();
		static void SetGlobalScale(float scale);
		static float GetNodeHeightScale();
		static void OnNodeSizeSet();

		//METHODS

		PreviewNodeRep();
		~PreviewNodeRep();

		virtual int Width();
		virtual int Height();

		void SetId(int id){m_id = id;}
		int GetId(){return m_id;}
		QPointF GetScenePos();
	
	protected:

		//CLASS STATIC DEFINITIONS

		static float m_sGlobalScale;
		static float m_sNodeHeightScale;
		static QRectF m_sScaledDrawRect;
		static QRectF m_sScaledTitleRect;
		static QRectF s_ownTitleRect;

		//METHODS

		QRectF & OnGetTitleRect();
		virtual QRectF OnCalcBoundRect() const;
		virtual void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget /* = 0 */);

	private:

		//MEMBER

		int m_id;
}; 

#endif //PREVIEWNODE_H