#ifndef PREVIEW_H
#define PREVIEW_H

/******************************************************************************\
*                                                                              *
* 21/4/2009                                                                    *
* Preview - Header File                                                        *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/
/******************************************************************************\
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX DESCRIPTION XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
\******************************************************************************/

//REQUIRED HEADERS 

#include <Definitions.h>
#include <QGraphicsRectItem>
#include <QGraphicsItemGroup>
#include <PreViewNodeRep.h>

//DECLARATIONS

class View;
class QGraphicsTextItem;

//PUBLIC DEFINITIONS TYPEDEFS

//

/******************************************************************************\
* CLASS                                                                        *
\******************************************************************************/
class Preview : public QGraphicsRectItem
{
	public:

		//CLASS STATIC DEFINITIONS

		

		//ENUM //VAR //METHODS 

		//METHODS

		Preview(View &view);
		~Preview();

		void Adjust(int newNodeWidth, int newNodeHeight);
		void UpdateGeometry(View &view);
		PreviewNodeRep & CreatePreviewNode(bool bGroupVisible);
		PreviewNodeRep * GetPreviewNode(int id);
		void ClearPreview();
	
		//MEMBER

	protected:

		//CLASS STATIC DEFINITIONS

		//ENUM //VAR //METHODS

		//METHODS
		void mousePressEvent(QGraphicsSceneMouseEvent *event);
		void mouseMoveEvent(QGraphicsSceneMouseEvent *event);
		
		//MEMBER

	private:

		//CLASS STATIC DEFINITIONS

		//ENUM //VAR //METHODS

		//METHODS

		void Scroll(float dScroll);
		void UpdateCursor();
		float GetContentHeight();

		//MEMBER

		View *m_pView;
		int m_width;

		QGraphicsItemGroup *m_visiblePreviewGroup;
		QGraphicsItemGroup *m_nonVisiblePreviewGroup;
		QGraphicsTextItem *m_itemTextVisible;
		QGraphicsTextItem *m_itemTextInvisible;
		QGraphicsRectItem *m_pPeviewShadow;

		float m_visiblePreviewGroupY;
		float m_nonVisiblePreviewGroupY;

		float m_contentHeight;
		float m_rangeHeight;
		float m_currentScroll;
}; 

#endif //PREVIEW_H