/******************************************************************************\
*                                                                              *
* 24/4/2009                                                                    *
* LinkRep - Source File                                                        *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/

//REQUIRED HEADERS 

#include <TreeLinkRep.h>
#include <TreeNodeRep.h>
#include <QGraphicsSceneMouseEvent>
#include <QGraphicsScene>
#include <QPainter>
#include <QRectF>
#include <QCursor>
#include <Memory/mmgr.h>

//NAMESPACE

using namespace std;

//PRIVATE DEFINITIONS TYPEDEFS

//

/****************************************************************************\
* STATIC                                                                     *
\****************************************************************************/

//MEMBER

//METHODS


/****************************************************************************\
* CD                                                                         *
\****************************************************************************/

TreeLinkRep::TreeLinkRep( NodeRep *from, NodeRep *to, QGraphicsItem *parent /*= NULL*/ ) 
: QGraphicsPathItem(parent),
  nodeFrom(from),
  nodeTo(to)
{
	setZValue(-10);
	setPen(QPen(QColor(150,150,150)));
}

TreeLinkRep::~TreeLinkRep()
{
	scene()->removeItem(this);
}

/****************************************************************************\
* PUBLIC CLASS FUNCTIONS                                                     *
\****************************************************************************/
void TreeLinkRep::SetTreeNodeTo(NodeRep *to)
{
	nodeTo = to;
}

void TreeLinkRep::SetPosition()
{
	QPointF fromPos(nodeFrom->pos());
	fromPos.setY(fromPos.y() + nodeFrom->Height()/2.0f);

	QPointF toPos(nodeTo->pos());
	toPos.setX(toPos.x() + nodeTo->Width());
	toPos.setY(toPos.y() + nodeTo->Height()/2.0f);
	
	QPainterPath path;
	
	path.moveTo(fromPos);
	path.cubicTo(fromPos.x() - 30, fromPos.y(), toPos.x() + 30, toPos.y(), toPos.x(), toPos.y());
	this->setPath(path);
}

/****************************************************************************\
* PROTECTED CLASS FUNCTIONS                                                  *
\****************************************************************************/

/****************************************************************************\
* PRIVATE CLASS FUNCTIONS                                                    *
\****************************************************************************/
