#ifndef TREEPLUS_H
#define TREEPLUS_H

/******************************************************************************\
*                                                                              *
* 1/4/2009                                                                     *
* TreePlus - Header File                                                       *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/
/******************************************************************************\
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX DESCRIPTION XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
\******************************************************************************/

//REQUIRED HEADERS 

#include <Definitions.h>
#include <QMainWindow>
#include <UI/UI_INCLUDE/ui_mainWidget.h>
#include <TreePlusSettings.h>

//DECLARATIONS

class View;
class Scene;
class Graph;
class Tree;
class QCloseEvent;

//PUBLIC DEFINITIONS TYPEDEFS

//

/******************************************************************************\
* CLASS                                                                        *
\******************************************************************************/
class TreePlus : public QMainWindow
{
	Q_OBJECT;

	public:

		//CLASS STATIC DEFINITIONS

		//ENUM //VAR //METHODS 

		//METHODS

		TreePlus();
		~TreePlus();

		bool Create();
		inline Scene * const GetScene(){return m_pScene;}
		inline View * const GetView(){return m_pView;}
		inline TreePlusSettings * const GetSettings(){return &m_settings;}

	protected:

		//CLASS STATIC DEFINITIONS

		//ENUM //VAR //METHODS

		//METHODS

		void closeEvent(QCloseEvent *event);

		//MEMBER

	private slots:

		//METHODS

		void MenuTriggered(QAction *);
		void ApplySettings();
		void Exit();

	private:

		//MEMBER

		TreePlusSettings m_settings;
		SettingsData m_settingsData;
		Ui::MainWindow m_ui;
		View *m_pView;
		Scene *m_pScene;
		Graph *m_pGraph;
		Tree *m_pTree;
}; 

#endif //KLEX_TREEPLUS_H