#ifndef TREEPLUSSETTINGS_H
#define TREEPLUSSETTINGS_H

/******************************************************************************\
*                                                                              *
* 26/5/2009                                                                    *
* TreePlusSettings - Header File                                               *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/
/******************************************************************************\
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX DESCRIPTION XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
\******************************************************************************/

//REQUIRED HEADERS 

#include <Definitions.h>
#include <QDialog>
#include <QColor>
#include <UI/UI_INCLUDE/ui_settings.h>

//DECLARATIONS

//

//PUBLIC DEFINITIONS TYPEDEFS

struct SettingsData
{
	QColor m_colNodeIngoing;
	QColor m_colNodeOutgoing;
	QColor m_colNodeBidirectional;
	QColor m_colNodeSelected;
	QColor m_colSceneBg;
	QColor m_colPreviewBg;
	QColor m_colNodeLabels;
	int m_fontSize;
	int m_animationDuration;
	bool m_animateCamera;
	int m_siblingSpacing;
	int m_subtreeSpacing;
	int m_levelSpacing;
	bool m_drawArrows;
	bool m_drawInfofields;
	int m_orderBy;
	int m_sortBy;
	int m_nodeWidth;
	int m_nodeHeight;
	bool m_bLayoutChange;
};

/******************************************************************************\
* CLASS                                                                        *
\******************************************************************************/
class TreePlusSettings : public QDialog
{
	Q_OBJECT;

	public:

		//CLASS STATIC DEFINITIONS

		//ENUM //VAR //METHODS 

		//METHODS

		TreePlusSettings();
		~TreePlusSettings();

		void GetData(SettingsData &data);

		//MEMBER

		//

	protected:

		//CLASS STATIC DEFINITIONS

		//ENUM //VAR //METHODS

		//METHODS

		//

		//MEMBER

		//

	signals:
	
		void Apply();
		
	private slots :

		void apply(QAbstractButton*);
		void SelectColor();
	
	private:

		//CLASS STATIC DEFINITIONS

		//ENUM //VAR //METHODS

		//METHODS

		bool LayoutChanged(SettingsData &data);

		//MEMBER

		Ui::Settings m_ui;
		
}; 

#endif //TREEPLUSSETTINGS_H