#ifndef VIEW_H
#define VIEW_H

/******************************************************************************\
*                                                                              *
* 1/4/2009                                                                     *
* View - Header File                                                           *
*                                                                              *
* (c) Robert Hausmair, Christoph Winklhofer                                    *
*                                                                              *
\******************************************************************************/
/******************************************************************************\
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX DESCRIPTION XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
\******************************************************************************/

//REQUIRED HEADERS 

#include <Definitions.h>
#include <QGraphicsView>
#include <Preview.h>

//DECLARATIONS

//

//PUBLIC DEFINITIONS TYPEDEFS

//

/******************************************************************************\
* CLASS                                                                        *
\******************************************************************************/
class View : public QGraphicsView
{
	Q_OBJECT;

	public:

		//CLASS STATIC DEFINITIONS

		//ENUM //VAR //METHODS 

		//METHODS

		View(QWidget *parent = NULL);
		~View();

		float GetCurrentScale(){return m_currentScale;}
		void SetScaleRange(float scaleMin, float scaleMax);
		inline Preview * GetPreview(){return m_pPreview;}

		void SetPreviewBgColor(QColor &col);
		void SetSceneBgColor(QColor &col);

		void LockInput(bool tf);

		void LookAt(QRectF &frame);
		QRectF ComputeToRect(QRectF &rect, QPointF &nodePos);
		QRectF GetViewRect();
		
		
		//MEMBER

	protected:

		//CLASS STATIC DEFINITIONS

		//ENUM //VAR //METHODS

		//METHODS
		
		virtual void mouseDoubleClickEvent(QMouseEvent *event);
		virtual void mousePressEvent(QMouseEvent *event);
		virtual void mouseReleaseEvent(QMouseEvent *event);
		virtual void mouseMoveEvent(QMouseEvent *event);
		virtual void wheelEvent(QWheelEvent *event);
		virtual void resizeEvent(QResizeEvent *event);
		virtual void paintEvent(QPaintEvent *event);
		virtual void showEvent(QShowEvent *event);
		virtual bool viewportEvent(QEvent *event);
		
		//MEMBER

	private:

		//CLASS STATIC DEFINITIONS

		//ENUM //VAR //METHODS

		//METHODS

		void DoScale(float scale);

		//MEMBER

		Preview *m_pPreview;
		QColor m_previewBgColor;
		
		float m_currentScale;
		float m_minScale;
		float m_maxScale;
		QGraphicsRectItem *m_visibleFrame;
		
}; 

#endif //VIEW_H